//COMPCODE JOB (SYS),'INSTALL COMPCODE',CLASS=A,MSGCLASS=A              00010000
//********************************************************************* 00020000
//* THIS JOB INSTALLS COMPCODE INTO SYS2.LINKLIB.  TO CHANGE TO AN    * 00030000
//* ALTERNATE LOAD LIBRARY, CHANGE THE OVERRIDE NEAR THE END OF THE   * 00040000
//* JOBSTREAM.  IN ORDER TO SEND THE RESULTS TO A TSO USER ID, THE    * 00050000
//* LOAD MODULE MUST EXECUTE FROM AN AUTHORIZED LOAD LIBRARY.         * 00060000
//********************************************************************* 00070000
//*                                                                     00080000
// EXEC ASMFCL,MAC1='SYS1.AMODGEN',PARM.ASM='LIST,LOAD,NODECK,XREF'     00090000
//ASM.SYSIN DD *                                                        00100000
* THIS PROGRAM IS DESIGNED TO REPORT STEP COMPLETION CODES FOR BATCH    00110000
*                                                                       00120000
* JOBS.  WHAT AND WHERE IT WRITES IS DETERMINED BY A PARAMETER LIST     00130000
*                                                                       00140000
* AND A DD STATEMENT.  THE PROGRAM IS TO BE RUN AS ITS OWN JOBSTEP      00150000
*                                                                       00160000
* FOLLOWING ANY JOBSTEPS THAT IT IS TO REPORT ON.  FOLLOWING IS A JCL   00170000
*                                                                       00180000
* EXAMPLE:                                                              00190000
*                                                                       00200000
* //*                                                                   00210000
* //COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                               00220000
* //         PARM='USER=(RWGV3),ROUT=(2,3,11),STEP=(ASMFCL.*,TESTER)'   00230000
* //SYSPRINT DD   DSN=RWGV3.SYSPRINT,DISP=MOD                           00240000
* //*                                                                   00250000
*                                                                       00260000
* (1)    COND=EVEN SHOULD ALWAYS BE SPECIFIED SO THAT THE STEP WILL     00270000
*        EXECUTE EVEN IF A PREVIOUS STEP HAS ABENDED.                   00280000
*                                                                       00290000
* (2)    VALID PARMS ARE AS FOLLOWS:                                    00300000
*                                                                       00310000
*    (A) USER= SPECIFIES WHICH USER(S) ARE TO BE NOTIFIED BY COMPCODE.  00320000
*              THIS PARAMETER IS OPTIONAL.  THE USER LIST MUST BE       00330000
*              ENCLOSED IN PARENTHESIS' EVEN IF ONLY ONE USER IS        00340000
*              SPECIFIED. EX. USER=(S001,S002) OR USER=(S001) .         00350000
*              THE MAXIMUM NUMBER OF USERS IS THREE.  IF NO USERS       00360000
*              ARE SPECIFIED, NO USERS WILL BE NOTIFIED.                00370000
*                                                                       00380000
*    (B) ROUT= SPECIFIES THE ROUTE CODES THAT THE MESSAGE(S) ARE TO BE  00390000
*              SENT TO.  THIS PARAMETER IS OPTIONAL.  THE ROUTCDE LIST  00400000
*              MUST BE ENCLOSED IN PARENTHESIS' EVEN IF ONLY ONE        00410000
*              ROUTE CODE IS SPECIFIED. EX. ROUT=(1,2,3) OR ROUT=(3).   00420000
*              VALID ROUTE CODES ARE 1-16.  IF NO ROUTE CODES ARE       00430000
*              SPECIFIED, NO MESSAGES WILL BE SENT TO OPERATOR          00440000
*              CONSOLES.                                                00450000
*                                                                       00460000
*    (C) STEP= SPECIFIES THE STEP(S) THAT COMPCODE IS TO REPORT ON.     00470000
*              THIS PARAMETER IS OPTIONAL.  IF OMITTED, ALL STEPS WILL  00480000
*              BE REPORTED ON (EXCEPT FOR STEPS THAT HAVE NOT YET EX-   00490000
*              CUTED OR THE "COMPCODE" STEP, BOTH OF WHICH ARE NEVER    00500000
*              LISTED) . THE STEP LIST MUST BE ENCLOSED IN PAREN-       00510000
*              THESIS' EVEN IF ONLY ONE STEP IS SPECIFIED.  STEPS MUST  00520000
*              BE INDICATED IN ONE OF THREE WAYS:                       00530000
*                                                                       00540000
*        (1)   PROGRAM EXECUTION - WHERE THE EXEC CARD SPECIFIES PGM= . 00550000
*              FOR //STEP1 DD PGM=IEBGENER ,                            00560000
*              THE STEP PARM WOULD READ : STEP=(STEP1,ETC,ETC)          00570000
*                                                                       00580000
*        (2)   PROC EXECUTION(SINGLE STEP) - WHERE THE EXEC CARD        00590000
*              SPECIFIES A PROC AND ONLY ONE STEP OF THE PROC IS TO     00600000
*              BE REPORTED ON.                                          00610000
*              FOR //ASMNLINK EXEC ASMFCL ,                             00620000
*              TO GET ONLY THE LKED STEP,                               00630000
*              THE STEP PARM WOULD READ : STEP=(ASMNLINK.LKED,ETC,ETC)  00640000
*                                                                       00650000
*        (3)   PROC EXECUTION(ALL STEPS) - WHERE THE EXEC CARD          00660000
*              SPECIFIES A PROC AND ALL STEPS FOR THE PROC ARE TO       00670000
*              BE REPORTED ON.                                          00680000
*              FOR //ASMNLINK EXEC ASMFCL ,                             00690000
*              TO GET ALL STEPS,                                        00700000
*              THE STEP PARM WOULD READ : STEP=(ASMNLINK.*,ETC,ETC)     00710000
*                                                                       00720000
* (3)    SYSPRINT DD STATEMENT - IF A SYSPRINT DD STATEMENT IS          00730000
*        INCLUDED, THE MESSAGE WILL BE WRITTEN INTO THE DATASET         00740000
*        SPECIFIED IN ADDITION TO THE USER= AND ROUT= REPORTING.  IF    00750000
*        THE DATASET EXISTS AND HAS DCB ATTRIBUTES, THEY ARE NOT        00760000
*        CHANGED.  IF NO DCB ATTRIBUTES ARE SPECIFIED, THE DATA         00770000
*        IS WRITTEN AS RECFM=FB,LRECL=133,BLKSIZE=6118.                 00780000
*                                                                       00790000
* (4)    SNAPDUMP DD STATEMENT - THIS DD STATEMENT IS TO BE USED FOR    00800000
*        DIAGNOSTIC PURPOSES ONLY.  IF INCLUDED, A SNAPDUMP OF THE      00810000
*        PERTINENT CONTROL BLOCKS WILL BE DONE.  NOTE THAT THE DCB      00820000
*        ATTRIBUTES FOR THIS DCB ARE HARD-CODED TO RECFM=VBA,LRECL=125, 00830000
*        BLKSIZE=1632, A RESTRICTION IMPOSED BY THE SNAP FACILITY.      00840000
*                                                                       00850000
* NOTE:  THAT THIS PROGRAM MUST RUN APF-AUTHORIZED IF THE "USER="       00860000
*                                                                       00870000
*        PARAMETER IS SPECIFIED.                                        00880000
*                                                                       00890000
         MACRO                                                          00900000
&NAME    H2C   &TO,&FROM,&LEN                                           00910000
.*       GBLA  &H2CCNT                                            *JLM* 00920000
         GBLA  &H2CCNT,&TOLEN,&FROMLEN                            *JLM* 00930000
.*                                                                      00940000
         AIF   ('&TO' EQ '').ERR1                                       00950000
         AIF   ('&LEN' EQ '').ERR1                                      00960000
         AIF   ('&FROM' EQ '').ERR1                                     00970000
.*                                                                      00980000
&TOLEN   SETA  &LEN+1                                                   00990000
&FROMLEN SETA  &LEN/2+1                                                 01000000
*                                                                       01010000
* THIS MACRO TRANSLATES HEX DATA TO EBCDIC.  NOTICE THAT THE "FROM"     01020000
*                                                                       01030000
* AND "TO" FIELDS MUST HAVE AN EXTRA BYTE FOLLOWING THEM TO ALLOW THE   01040000
*                                                                       01050000
* TRANSLATION TO TAKE PLACE.                                            01060000
*                                                                       01070000
         AIF   ('&TO'(1,1) EQ '(').REGTO                                01080000
&NAME    LA    15,&TO              LOAD ADDR OF "TO" AREA               01090000
         AGO   .CHKFROM                                                 01100000
.REGTO   ANOP                                                           01110000
&NAME    LR    15,&TO              LOAD ADDR OF "TO" AREA               01120000
.*                                                                      01130000
.CHKFROM AIF   ('&FROM'(1,1) EQ '(').REGFROM                            01140000
         LA    14,&FROM            LOAD ADDR OF "FROM" AREA             01150000
         AGO   .REGDONE                                                 01160000
.REGFROM LR    14,&FROM            LOAD ADDR OF "FROM" AREA             01170000
.*                                                                      01180000
.REGDONE ANOP                                                           01190000
         UNPK  0(&TOLEN,15),0(&FROMLEN,14) CONVERT ZONES TO EBCDIC      01200000
         AIF   (&H2CCNT EQ 1).NOT1ST                                    01210000
&H2CCNT  SETA  1                                                        01220000
         BAL   1,H2C0002           LOAD ADDR OF PARTIAL TBL AND BRANCH  01230000
H2C0001  DC    C'0123456789ABCDEF' PARTIAL TRANSLATE TABLE              01240000
         AGO   .H2C0002                                                 01250000
.*                                                                      01260000
.NOT1ST  LA    1,H2C0001           LOAD TBL ADDR FROM LAST INVOCATION   01270000
         AGO   .SKPALGN                                                 01280000
.H2C0002 ANOP                                                           01290000
H2C0002  DS    0H                                                       01300000
.SKPALGN ANOP                                                           01310000
         LA    0,C'0'              LOAD OFFSET INTO TABLE               01320000
         SR    1,0                 SET PTR TO BEGINNING OF TABLE        01330000
         TR    0(&LEN,15),0(1)     TRANSLATE TO CORRECT EBCDIC CHARS    01340000
         MEXIT                                                          01350000
*                                                                       01360000
.ERR1    MNOTE 8,'REQUIRED OPERAND NOT SPECIFIED'                       01370000
         MEND                                                           01380000
         MACRO                                                          01390000
&NAME    DCBEXIT &RECFM=,&LRECL=,&BLKSIZE=                              01400000
.*                                                                      01410000
         LCLA  &I,&D                                                    01420000
&I       SETA  1                                                        01430000
&D       SETA  &SYSNDX                                                  01440000
.*                                                                      01450000
&NAME    DS    0F                                                       01460000
         DC    X'85',AL3(*+3)      END OF LIST, DCB EXIT, EXIT ADDRESS  01470000
*                                                                       01480000
         USING *,R15               OBTAIN ADDRESSABILITY FOR EXIT RTN   01490000
         SLR   R0,R0               ZERO REG0                            01500000
.*                                                                      01510000
         AIF   ('&RECFM' EQ '').LRECL                                   01520000
*                                                                       01530000
         CLI   36(R1),X'00'        IS THE RECFM ZERO?                   01540000
         BNE   D&D.I&I             IF NOT, DON'T REPLACE IT             01550000
         OI    36(R1),DCBRECF      RECFM=F                              01560000
.*                                                                      01570000
.LRECL   AIF   ('&LRECL' EQ '').BLKSIZE                                 01580000
*                                                                       01590000
D&D.I&I  DS    0H                                                       01600000
&I       SETA  &I+1                                                     01610000
         CH    R0,52(,R1)          IS THE LRECL ZERO?                   01620000
         BNE   D&D.I&I             IF NOT, DON'T REPLACE IT             01630000
         MVC   52(2,R1),=AL2(&LRECL) ELSE MOVE IN SPECIFIED VALUE       01640000
.*                                                                      01650000
.BLKSIZE AIF   ('&BLKSIZE' EQ '').EXIT                                  01660000
*                                                                       01670000
D&D.I&I  DS    0H                                                       01680000
&I       SETA  &I+1                                                     01690000
         CH    R0,62(,R1)          IS THE BLKSIZE ZERO?                 01700000
         BNE   D&D.I&I             IF NOT, DON'T REPLACE IT             01710000
         MVC   62(2,R1),=AL2(&BLKSIZE) ELSE MOVE IN SPECIFIED VALUE     01720000
.*                                                                      01730000
.EXIT    ANOP                                                           01740000
*                                                                       01750000
D&D.I&I  DS    0H                                                       01760000
         DROP  R15                 DISCONTINUE MAPPING                  01770000
         BR    R14                 RETURN                               01780000
         MEND                                                           01790000
         PRINT NOGEN                                                    01800000
COMPCODE CSECT                     DEFINE CSECT NAME                    01810000
R0       EQU   0                   E                                    01820000
R1       EQU   1                     Q                                  01830000
R2       EQU   2                       U                                01840000
R3       EQU   3                         A                              01850000
R4       EQU   4                           T                            01860000
R5       EQU   5                             E                          01870000
R6       EQU   6                                                        01880000
R7       EQU   7                   R                                    01890000
R8       EQU   8                     E                                  01900000
R9       EQU   9                       G                                01910000
R10      EQU   10                        I                              01920000
R11      EQU   11                          S                            01930000
R12      EQU   12                            T                          01940000
R13      EQU   13                              E                        01950000
R14      EQU   14                                R                      01960000
R15      EQU   15                                  S                    01970000
         B     BEGIN-*(R15)        BRANCH TO BEGINNING OF PROGRAM       01980000
         DC    17F'0'              REST OF SAVEAREA                     01990000
PGMNAME  DC    CL8'COMPCODE'       PROGRAM NAME                         02000000
         DC    CL8'R.W.GLOS'       PROGRAMMER NAME                      02010000
         DC    CL8'&SYSDATE'       ASSEMBLY DATE                        02020000
         DC    CL8'&SYSTIME'       ASSEMBLY TIME                        02030000
BEGIN    DS    0H                  ALIGN TO HALFWORD BOUNDARY           02040000
         STM   R14,R12,12(R13)     SAVE CALLER'S REGISTERS              02050000
         ST    R13,4(,R15)         SAVE ADDRESS OF CALLER'S SAVEAREA    02060000
         ST    R15,8(,R13)         STORE ADDRESS OF MY SAVEAREA         02070000
         LR    R13,R15             LOAD 13 WITH ADDR OF SAVEAREA & PGM  02080000
         USING COMPCODE,R13        SET UP ADDRESSABILITY FOR PROGRAM    02090000
         USING PSA,R0              MAP PSA                              02100000
*                                                                       02110000
*        PARSE INITIALIZATION                                           02120000
*                                                                       02130000
         L     R1,0(,R1)           GET ADDRESS OF PARMLIST              02140000
         LH    R10,0(,R1)          GET LENGTH OF PARMLIST               02150000
         LTR   R10,R10             WAS A PARMLIST PROVIDED?             02160000
         BZ    PARSDONE            IF NOT, SKIP PARSING PARMLIST        02170000
         LA    R10,1(R10,R1)       SET POINTER TO LAST BYTE IN PARMLIST 02180000
         CLI   0(R10),C')'         IS THE LAST BYTE A ")" ?             02190000
         BE    FIRSTPRM            IF SO, CONTINUE                      02200000
*                                                                       02210000
         MVI   RETCODE+3,X'08'     SET NON-ZERO RETURN CODE             02220000
         LA    R1,PARMERR1         LOAD ADDRESS OF ERROR MESSAGE        02230000
         LA    R11,END             LOAD RETURN ADDRESS                  02240000
         B     ERRORRTN            GO TO ERROR ROUTINE                  02250000
*                                                                       02260000
FIRSTPRM DS    0H                                                       02270000
         LA    R9,2(,R1)           SET POINTER TO 1ST KEYWORD           02280000
         B     PARSLVL1            GO TO LEVEL 1 PARSE ROUTINE          02290000
*                                                                       02300000
         TITLE 'PERFORM SOME ADDITIONAL INITIALIZATION FOR PROCESSING'  02310000
*                                                                       02320000
PARSDONE DS    0H                                                       02330000
*        OPEN SYSPRINT AND SNAPDUMP DCBS IF THEIR DD CARDS EXISTS       02340000
*                                                                       02350000
         L     R1,PSATOLD          GET ADDRESS OF CURRENT TCB           02360000
         USING TCB,R1              MAP IT                               02370000
         L     R8,TCBTIO           GET ADDRESS OF TIOT                  02380000
         USING TIOT1,R8            MAP IT                               02390000
         LA    R8,TIOENTRY         BUMP PTR TO 1ST DD ENTRY             02400000
         USING TIOENTRY,R8         MAP IT                               02410000
         XR    R7,R7               CLEAR LENGTH HOLDER                  02420000
*                                                                       02430000
TIOTLOOP DS    0H                                                       02440000
         CLC   TIOENTRY(4),=4X'00' IS THIS ENTRY THE END?               02450000
         BE    TIOTDONE            IF SO, WE'RE DONE                    02460000
         CLC   TIOEDDNM(8),=C'SYSPRINT' IS THIS A SYSPRINT DD CARD?     02470000
         BE    OPENSYSP            IF SO, GO OPEN DCB                   02480000
         CLC   TIOEDDNM(8),=C'SNAPDUMP' IS THIS A SNAPDUMP DD CARD?     02490000
         BE    OPENSNAP            IF SO, GO OPEN DCB                   02500000
         B     BUMPTIOT            ELSE, BUMP PTR TO NEXT TIOT ENTRY    02510000
*                                                                       02520000
OPENSYSP DS    0H                                                       02530000
         OPEN  (SYSPRINT,(OUTPUT)) OPEN THE DCB                         02540000
         OI    FLAGS,PRINTIT       TURN ON FLAG TO ACTIVATE PRINT RTN   02550000
         B     BUMPTIOT            CONTINUE SEARCH FOR OTHER DDNAME     02560000
*                                                                       02570000
OPENSNAP DS    0H                                                       02580000
         OPEN  (SNAPDUMP,(OUTPUT)) OPEN THE DCB                         02590000
         OI    FLAGS,SNAPIT        TURN ON FLAG TO ACTIVATE SNAP RTN    02600000
         B     BUMPTIOT            CONTINUE SEARCH FOR OTHER DDNAME     02610000
*                                                                       02620000
BUMPTIOT DS    0H                                                       02630000
         IC    R7,TIOELNGH         GET THE LENGTH OF THIS ENTRY         02640000
         LA    R8,TIOENTRY(R7)     BUMP THE POINTER TO THE NEXT ENTRY   02650000
         B     TIOTLOOP            GO CHECK NEXT ENTRY                  02660000
         DROP  R8                  DISCONTINUE MAPPING                  02670000
*                                                                       02680000
TIOTDONE DS    0H                                                       02690000
         EJECT                                                          02700000
*                                                                       02710000
*        MAKE SURE WE'RE APF-AUTHORIZED IF USER= WAS SPECIFIED          02720000
*                                                                       02730000
         TM    FLAGS,SENDIT        WAS "USER=" SPECIFIED?               02740000
         BZ    GETTIME             IF NOT, SKIP THIS                    02750000
         TESTAUTH FCTN=1           SEE IF WE'RE AUTH'D (TO ISSUE CMDS)  02760000
         LTR   R15,R15             ARE WE?                              02770000
         BZ    GETTIME             IF SO, SKIP REST OF THIS             02780000
         LA    R1,PARMERR5         LOAD ADDRESS OF ERROR MESSAGE        02790000
         BAL   R11,ERRORRTN        GO TO ERROR ROUTINE                  02800000
         MVI   RETCODE+3,X'08'     SET NON-ZERO RETURN CODE             02810000
         TM    FLAGS,WTOIT+PRINTIT WERE ANY OTHER OPTIONS SELECTED?     02820000
         BZ    END                 IF NOT, GO END                       02830000
         MVI   RETCODE+3,X'04'     ELSE, SET LESS-SEVERE RETURN CODE    02840000
         NI    FLAGS,255-SENDIT    TURN OFF SEND ROUTINE                02850000
*                                                                       02860000
*        GET TIME AND DATE                                              02870000
*                                                                       02880000
GETTIME  DS    0H                                                       02890000
         TIME  DEC                 GET TIME AND DATE                    02900000
         ST    R1,PACKWORK         STORE PACKED DATE                    02910000
         UNPK  DATEWORK(5),PACKWORK+1(3) UNPACK DATE                    02920000
         OI    DATEWORK+4,X'F0'    CORRECT THE SIGN                     02930000
         MVC   DATE(2),DATEWORK    MOVE YEAR INTO MESSAGE               02940000
         MVC   DATE+3(3),DATEWORK+2 MOVE JULIAN DAY INTO MESSAGE        02950000
*                                                                       02960000
         ST    R0,PACKWORK         STORE PACKED TIME                    02970000
         UNPK  TIMEWORK(7),PACKWORK(4) UNPACK TIME                      02980000
         MVC   TIME(2),TIMEWORK    MOVE HOURS INTO MESSAGE              02990000
         MVC   TIME+3(2),TIMEWORK+2 MOVE MINUTES INTO MESSAGE           03000000
         MVC   TIME+6(2),TIMEWORK+4 MOVE SECONDS INTO MESSAGE           03010000
         EJECT                                                          03020000
*                                                                       03030000
*        GET JOBNAME, JESJOBID, AND POINTER TO FIRST SCT                03040000
*                                                                       03050000
         L     R1,PSATOLD          GET ADDRESS OF CURRENT TCB (US)      03060000
         USING TCB,R1              MAP IT                               03070000
         ICM   R1,B'0111',TCBJSCBB GET ADDRESS OF JSCB                  03080000
         USING IEZJSCB,R1          MAP IT                               03090000
         L     R12,JSCBJCT         GET ADDRESS OF JCT                   03100000
         LA    R12,16(,R12)        BUMP PTR OVER JCT PREFIX             03110000
         USING INJMJCT,R12         MAP IT                               03120000
         L     R8,JSCBSSIB         GET ADDRESS OF SSIB                  03130000
         USING SSIB,R8             MAP IT                               03140000
         MVC   JESJOBID(1),SSIBJBID MOVE J, T, OR S IDENTIFIER INTO MSG 03150000
         MVC   JESJOBID+1(4),SSIBJBID+4 MOVE JES JOB NUMBER INTO MSG    03160000
         DROP  R8                  DISCONTINUE MAPPING WITH R1          03170000
         MVC   JOBNAME(8),JCTJNAME MOVE JOBNAME INTO MESSAGE            03180000
*                                                                       03190000
         TM    FLAGS,SNAPIT        DID A SNAPDUMP DDNAME EXIST?         03200000
         BZ    SCTS                IF NOT, SKIP SNAPS                   03210000
         ST    R12,SNAPLIST        STORE ADDR OF JCT                    03220000
         LA    R0,176(,R12)        LOAD ADDR OF END OF JCT              03230000
         ST    R0,SNAPEND          STORE IT                             03240000
         OI    SNAPEND,X'80'       TURN ON END-OF-LIST INDICATOR        03250000
         LA    R0,JCTHDR           LOAD ADDR OF TITLE LINE              03260000
         ST    R0,HDRLIST          STORE IT                             03270000
         OI    HDRLIST,X'80'       TURN ON END-OF-LIST INDICATOR        03280000
         SNAP  DCB=SNAPDUMP,LIST=SNAPLIST,STRHDR=HDRLIST STAP AREA      03290000
*                                                                       03300000
*        ST    R8,SNAPLIST         STORE ADDR OF SSIB                   03310000
*        LA    R0,36(,R8)          LOAD ADDR OF END OF SSIB             03320000
*        ST    R0,SNAPEND          STORE IT                             03330000
*        OI    SNAPEND,X'80'       TURN ON END-OF-LIST INDICATOR        03340000
*        LA    R0,SSIBHDR          LOAD ADDR OF TITLE LINE              03350000
*        ST    R0,HDRLIST          STORE IT                             03360000
*        OI    HDRLIST,X'80'       TURN ON END-OF-LIST INDICATOR        03370000
*        SNAP  DCB=SNAPDUMP,LIST=SNAPLIST,STRHDR=HDRLIST STAP AREA      03380000
*                                                                       03390000
         TITLE 'PROCESS SCTS'                                           03400000
*                                                                       03410000
SCTS     DS    0H                                                       03420000
         L     R10,JCTSDKAD        GET TTR ADDRESS OF FIRST SCT         03430000
         L     R3,LISTPTR          LOAD ADDRESS OF END OF USED LIST     03440000
SCTLOOP  DS    0H                                                       03450000
         SRL   R10,8               CORRECT SCT ADDRESS                  03460000
         LA    R10,16(,R10)        BUMP PTR OVER SCT PREFIX             03470000
         USING INSMSCT,R10         MAP SCT                              03480000
*                                                                       03490000
         TM    FLAGS,SNAPIT        DID A SNAPDUMP DDNAME EXIST?         03500000
         BZ    NOSCTSNP            IF NOT, SKIP SNAPS                   03510000
         ST    R10,SNAPLIST        STORE ADDR OF SCT                    03520000
         LA    R0,176(,R10)        LOAD ADDR OF END OF SCT              03530000
         ST    R0,SNAPEND          STORE IT                             03540000
         OI    SNAPEND,X'80'       TURN ON END-OF-LIST INDICATOR        03550000
         LA    R0,SCTHDR           LOAD ADDR OF TITLE LINE              03560000
         ST    R0,HDRLIST          STORE IT                             03570000
         OI    HDRLIST,X'80'       TURN ON END-OF-LIST INDICATOR        03580000
         SNAP  DCB=SNAPDUMP,LIST=SNAPLIST,STRHDR=HDRLIST STAP AREA      03590000
*                                                                       03600000
NOSCTSNP DS    0H                                                       03610000
*        TM    SCTSTEND,SCTSTPND   THIS STEP BEEN EXECUTED(OR FLUSHED)? 03620000
         TM    SCTCATCT+2+4,X'C0'                                 *JLM* 03630000
         BO    SCTCOMP             IF SO, CONTINUE                      03640000
         TM    FLAGS,SNAPIT        DID A SNAPDUMP DDNAME EXIST?         03650000
         BZ    END                 IF NOT, WE'RE DONE                   03660000
         B     NEXTSCT             ELSE, RUN ALL SCTS                   03670000
*                                                                       03680000
SCTCOMP  DS    0H                                                       03690000
         CLC   SCTPGMNM(8),PGMNAME IS THIS ONE A COMPCODE?              03700000
         BE    NEXTSCT             IF SO, GO BUMP TO NEXT SCT           03710000
         CLI   STEPLIST,C'*'       NO STEPS SPECIFIED?                  03720000
         BE    SHOWIT              IF SO, SHOW ALL STEPS                03730000
         LA    R2,STEPLIST         SET POINTER TO BEGINNING OF STEPLIST 03740000
*                                                                       03750000
LOOP     DS    0H                                                       03760000
         CR    R2,R3               IS THIS THE END OF THE LIST?         03770000
         BNL   NEXTSCT             IF SO, GO BUMP PTR TO NEXT SCT       03780000
         CLI   8(R2),C'*'          STEPNAME.* SPECIFIED?                03790000
         BNE   CHECKALL            IF NOT, GO CHECK STEPNAME & PRCSTPNM 03800000
*                                                                       03810000
         CLC   0(8,R2),SCTSCLPC    ELSE, IS THIS STEPNAME IN THE LIST?  03820000
         BE    SHOWIT              IF SO, GO DISPLAY IT                 03830000
         LA    R2,16(,R2)          ELSE, BUMP TO NEXT LIST ENTRY,       03840000
         B     LOOP                AND TRY IT                           03850000
*                                                                       03860000
CHECKALL DS    0H                                                       03870000
         CLC   0(16,R2),SCTSCLPC   DO STEPNAME AND PRCSTPNM MATCH?      03880000
         BE    SHOWIT              IF SO, GO DISPLAY IT                 03890000
BUMPSCT  DS    0H                                                       03900000
         LA    R2,16(,R2)          ELSE, BUMP TO NEXT LIST ENTRY,       03910000
         B     LOOP                AND TRY IT                           03920000
*                                                                       03930000
         TITLE 'COMPLETE MESSAGE AND DISPLAY IT'                        03940000
*                                                                       03950000
SHOWIT   DS    0H                                                       03960000
         TM    SCTABCND,SCTABEND   DID THIS STEP ABEND?                 03970000
         BZ    CHKFLSH             IF NOT, GO CHECK FOR FLUSHED STEP    03980000
         MVC   RESULT(9),ABENDED   MOVE "ABEND" INTO MESSAGE            03990000
         LA    R0,4095             GET MAXIMUM USER ABEND CODE          04000000
         XR    R1,R1               ZERO REG                             04010000
         ICM   R1,B'0111',JCTACODE+1 GET ABEND CODE                     04020000
         CR    R1,R0               IS THIS A USER ABEND?                04030000
         BH    SYSTEM              IF NOT, PROCESS AS SYSTEM ABEND      04040000
*                                                                       04050000
         CVD   R1,PACKWORK         CONVERT ABEND VALUE TO DECIMAL       04060000
         UNPK  CONDCODE(5),PACKWORK+5(3) UPPACK IT INTO MSG             04070000
         OI    CONDCODE+4,X'F0'    CORRECT THE SIGN                     04080000
         MVI   CONDCODE,C'U'       MOVE IN USER ABEND IDENTIFIER        04090000
         MVI   CONDCODE+5,C','     ADD COMMA                            04100000
         B     BLANKFLD            SKIP PROCESSING NORMAL COND CODE     04110000
*                                                                       04120000
SYSTEM   DS    0H                                                       04130000
         SRL   R1,12               SHIFT TO LOW-ORDER BYTES             04140000
         ST    R1,ABEND            STORE IT                             04150000
         H2C   CONDCODE,ABEND+2,4  CONVERT SYSTEM ABEND CODE TO CHAR    04160000
         MVI   CONDCODE,C'S'       MOVE IN SYSTEM ABEND IDENTIFIER      04170000
         MVI   CONDCODE+4,C','     ADD COMMA                            04180000
         B     BLANKFLD            SKIP PROCESSING NORMAL COND CODE     04190000
*                                                                       04200000
CHKFLSH  DS    0H                                                       04210000
*        TM    SCTSTEND,SCTSTSRT   DID THIS STEP EVER START?            04220000
         TM    SCTCATCT+2+4,X'80'                                 *JLM* 04230000
         BO    CC                  IF SO, GO GET CONDITION CODE         04240000
         MVC   RESULT(9),FLUSHED   MOVE "FLUSHED" INTO MESSAGE          04250000
         MVC   CONDCODE(4),=C'----' MOVE DASHES INTO CONDE CODE FIELD   04260000
         MVI   CONDCODE+4,C','     ADD COMMA                            04270000
         B     BLANKFLD            SKIP PROCESSING NORMAL COND CODE     04280000
*                                                                       04290000
CC       DS    0H                                                       04300000
         MVC   RESULT(9),ENDED     MOVE "ENDED" INTO MESSAGE            04310000
         LH    R1,SCTSEXEC         GET STEP COMPLETION CODE             04320000
         CVD   R1,PACKWORK         CONVERT IT TO PACKED DECIMAL         04330000
         UNPK  CONDCODE(4),PACKWORK+5(3) UNPACK IT INTO DISPLAY FIELD   04340000
         OI    CONDCODE+3,X'F0'    CORRECT THE SIGN                     04350000
         MVI   CONDCODE+4,C','     ADD COMMA                            04360000
*                                                                       04370000
BLANKFLD DS    0H                                                       04380000
         MVI   STEPNAME,C' '       SEED BLANK                           04390000
         MVC   STEPNAME+1(16),STEPNAME BLANK OUT STEPNAME/PRCSTPNM FLD  04400000
         CLI   SCTSCLPC,C' '       DOES THIS STEP CALL A PROC?          04410000
         BNE   MOVEPROC            IF SO, GO MOVE IT AND PRCSTPNM IN    04420000
         MVC   STEPNAME(8),SCTSNAME MOVE PRCSTPNM INTO DISPLAY FIELD    04430000
         B     SENDRTN             GO DISPLAY IT                        04440000
*                                                                       04450000
MOVEPROC DS    0H                                                       04460000
         MVC   STEPNAME(8),SCTSCLPC MOVE IN STEPNAME                    04470000
         MVI   PERIOD,C'.'         MOVE IN SEPARATOR                    04480000
         MVC   PRCSTPNM(8),SCTSNAME MOVE IN PRCSTPNM                    04490000
         EJECT                                                          04500000
*                                                                       04510000
SENDRTN  DS    0H                                                       04520000
         TM    FLAGS,SENDIT        ARE WE SUPPOSED TO SEND IT?          04530000
         BZ    WTORTN              IF, NOT SKIP IT                      04540000
LMESSAGE EQU   71                                                 *JLM* 04550000
         MVC   SENDBUF(LMESSAGE),MESSAGE MOVE MESSAGE INTO BUFFER       04560000
*        APFAUTH ON                TURN ON APF-AUTHORIZATION            04570000
         MODESET MODE=SUP,KEY=ZERO GET INTO SUP STATE, KEY 0 FOR SVC34  04580000
         LA    R1,SEND             GET ADDRESS OF SEND PARMLIST         04590000
         XR    R0,R0               SPECIFY "SYSTEM-ENTERED COMMAND"     04600000
         SVC   34                  ISSUE COMMAND SVC                    04610000
         MODESET MODE=PROB,KEY=NZERO GET BACK INTO PROBLEM STATE        04620000
*        APFAUTH OFF               TURN OFF APF-AUTHORIZATION           04630000
*                                                                       04640000
WTORTN   DS    0H                                                       04650000
         TM    FLAGS,WTOIT         ARE WE SUPPOSED TO WTO IT?           04660000
         BZ    PRINTRTN            IF, NOT SKIP IT                      04670000
         MVC   WTOBUF(LMESSAGE),MESSAGE MOVE MESSAGE INTO BUFFER        04680000
         WTO   MF=(E,WTO)          WTO THE MESSAGE                      04690000
*                                                                       04700000
PRINTRTN DS    0H                                                       04710000
         TM    FLAGS,PRINTIT       ARE WE SUPPOSED TO PRINT IT?         04720000
         BZ    NEXTSCT             IF, NOT SKIP IT                      04730000
         MVC   PRINTBUF(LMESSAGE),MESSAGE MOVE MESSAGE INTO BUFFER      04740000
         PUT   SYSPRINT,PRINTBUF   PRINT THE MESSAGE                    04750000
*                                                                       04760000
NEXTSCT  DS    0H                                                       04770000
         ICM   R10,B'1111',SCTANSCT LOAD ADDRESS OF NEXT SCT,           04780000
         BNZ   SCTLOOP             AND PROCESS IT                       04790000
*                                                                       04800000
END      DS    0H                                                       04810000
         TM    SYSPRINT+48,X'10'   WAS THE SYSPRINT DCB OPENED?         04820000
         BZ    CLOSESNP            IF NOT, JUST END                     04830000
         CLOSE SYSPRINT            ELSE, CLOSE DCB                      04840000
*                                                                       04850000
CLOSESNP DS    0H                                                       04860000
         TM    SNAPDUMP+48,X'10'   WAS THE SNAPDUMP DCB OPENED?         04870000
         BZ    ALLDONE             IF NOT, JUST END                     04880000
         CLOSE SNAPDUMP            ELSE, CLOSE DCB                      04890000
*                                                                       04900000
ALLDONE  DS    0H                                                       04910000
         L     R15,RETCODE         LOAD RETURN CODE                     04920000
         L     R13,4(,R13)         RELOAD CALLER'S REGISTER 13          04930000
         L     R14,12(,R13)        RELOAD CALLER'S REGISTER 14          04940000
         LM    R0,R12,20(R13)      RESTORE CALLER'S REGISTERS           04950000
         BR    R14                 RETURN TO CALLER                     04960000
*                                                                       04970000
         TITLE 'PARSE ROUTINES'                                         04980000
*                                                                       04990000
*        LEVEL 1 PARSE ROUTINE (KEYWORD PROCESSING ROUTINE)             05000000
*                                                                       05010000
PARSLVL1 DS    0H                                                       05020000
         LA    R1,KEYWORDS         GET ADDRESS OF KEYWORD LIST          05030000
KEYLOOP  DS    0H                                                       05040000
         CLI   0(R1),C' '          IS THIS THE END OF THE KEYWORD LIST? 05050000
         BNE   CHECKKEY            IF NOT, CONTINUE                     05060000
*                                                                       05070000
         MVI   RETCODE+3,X'08'     SET NON-ZERO RETURN CODE             05080000
         LA    R1,PARMERR2         LOAD ADDRESS OF ERROR MESSAGE        05090000
         LA    R11,END             LOAD RETURN ADDRESS                  05100000
         B     ERRORRTN            GO TO ERROR ROUTINE                  05110000
*                                                                       05120000
CHECKKEY DS    0H                                                       05130000
         CLC   0(4,R9),0(R1)       IS THIS A VALID KEYWORD?             05140000
         BE    FOUNDKEY            IF SO, GO LOAD LEVEL 3 ROUTINE ADDRS 05150000
         LA    R1,12(,R1)          ELSE BUMP TO NEXT KEYWORD,           05160000
         B     KEYLOOP             AND TRY IT                           05170000
*                                                                       05180000
FOUNDKEY DS    0H                                                       05190000
         L     R7,4(,R1)           LOAD ADDRESS OF PRIMARY LEVEL 3 RTN  05200000
         L     R8,8(,R1)           LOAD ADDRESS OF LEVEL 3 END ROUTINE  05210000
         LA    R1,5(,R9)           LOAD ADDRESS PAST XXXX=              05220000
         B     PARSLVL2            GO TO LEVEL 2 PARSE ROUTINE          05230000
*                                                                       05240000
KEYWORDS DS    0F                                                       05250000
         DC    C'USER',A(PARSUSER,USEREND)                              05260000
         DC    C'ROUT',A(PARSROUT,ROUTEND)                              05270000
         DC    C'STEP',A(PARSSTEP,STEPEND)                              05280000
         DC    C' '                                                     05290000
         EJECT                                                          05300000
*                                                                       05310000
*        LEVEL 2 PARSE ROUTINE (DELIMITER PROCESSING ROUTINE)           05320000
*                                                                       05330000
PARSLVL2 DS    0H                                                       05340000
         CLI   0(R1),C'('          IS THIS A VALID "OPEN" DELIMITER     05350000
         BE    PARMSCAN            IF SO, CONTINUE                      05360000
*                                                                       05370000
         MVI   RETCODE+3,X'08'     SET NON-ZERO RETURN CODE             05380000
         LA    R1,PARMERR3         LOAD ADDRESS OF ERROR MESSAGE        05390000
         LA    R11,END             LOAD RETURN ADDRESS                  05400000
         B     ERRORRTN            GO TO ERROR ROUTINE                  05410000
*                                                                       05420000
PARMSCAN DS    0H                                                       05430000
         LA    R5,1(,R1)           SET BASE POINTER IN PARM             05440000
         LA    R6,1(,R5)           SET POINTER TO SCAN FOR DELIMITER    05450000
*                                                                       05460000
PARMLOOP DS    0H                                                       05470000
         CLI   0(R6),C','          IS THIS A PARM SEPARATOR?            05480000
         BE    PARMSEP             IF SO, GO PROCESS IT                 05490000
         CLI   0(R6),C')'          IS THIS PARM END?                    05500000
         BE    PARMEND             IF SO, GO PROCESS IT                 05510000
         LA    R6,1(,R6)           BUMP POINTER                         05520000
         B     PARMLOOP            PROCESS NEXT CHARACTER               05530000
*                                                                       05540000
PARMSEP  DS    0H                                                       05550000
         BALR  R11,R7              GO TO APPROPRIATE LEVEL 3 ROUTINE    05560000
         LR    R1,R6               COPY ADDRESS OF DELIMITER            05570000
         B     PARMSCAN            PROCESS NEXT PARM                    05580000
*                                                                       05590000
PARMEND  DS    0H                                                       05600000
         BALR  R11,R7              GO TO APPROPRIATE LEVEL 3 ROUTINE    05610000
         BALR  R11,R8              GO TO APPROPRIATE LVL 3 END ROUTINE  05620000
         CLI   1(R6),C','          IS THERE ANOTHER PARM KEYWORD?       05630000
         BNE   PARSDONE            IF NOT, PARSING IS DONE              05640000
*                                                                       05650000
         LA    R9,2(,R6)           ELSE, LOAD ADDRESS OF NEXT KEYWORD,  05660000
         B     PARSLVL1            AND GO PROCESS IT                    05670000
         EJECT                                                          05680000
*                                                                       05690000
*        LEVEL 3 ROUTINE (USER PARM AND USER END PROCESSING ROUTINES)   05700000
*                                                                       05710000
PARSUSER DS    0H                                                       05720000
         BR    R11                 NO PROCESSING TILL END OF PARM       05730000
*                                                                       05740000
USEREND  DS    0H                                                       05750000
         LR    R1,R6               COPY ADDRESS OF END OF PARM FIELD    05760000
         SR    R1,R9               GET LENGTH OF PARM (WITH KEYWORD)    05770000
*                                                                       05780000
         LA    R14,SENDBUF+LMESSAGE GET ADDR OF 1ST BYTE PAST MESSAGE   05790000
         MVI   0(R14),X'7D'        MOVE IN CLOSE QUOTE                  05800000
         MVI   1(R14),C','         MOVE IN COMMA                        05810000
*                                                                       05820000
         EX    R1,*+8              SAVE USER PARM FIELD FOR SEND CMD    05830000
         B     *+10                BRANCH AROUND EX ISN                 05840000
         MVC   2(0,R14),0(R9)      EX ISN                               05850000
*                                                                       05860000
         LA    R14,3(R1,R14)       BUMP POINTER PAST USER= PARM         05870000
         MVC   0(6,R14),=C',LOGON' MOVE IN END OF MESSAGE               05880000
         LA    R14,6(,R14)         GET END POINTER                      05890000
         LA    R15,SEND            GET ADDRESS OF SEND COMMAND          05900000
         SR    R14,R15             GET TOTAL LENGTH OF COMMAND          05910000
         STH   R14,SEND            STORE IT IN SEND PARMLIST            05920000
*                                                                       05930000
         OI    FLAGS,SENDIT        TURN ON FLAG TO ACTIVATE SEND RTN    05940000
         BR    R11                 RETURN TO CALLING ROUTINE            05950000
         EJECT                                                          05960000
*                                                                       05970000
*        LEVEL 3 ROUTINE (ROUT PARM AND ROUT END PROCESSING ROUTINES)   05980000
*                                                                       05990000
PARSROUT DS    0H                                                       06000000
         LH    R0,ROUTCDE          LOAD ACCUMULATED ROUTCDE             06010000
         LR    R1,R6               COPY END POINTER                     06020000
         SR    R1,R5               GET LENGTH OF PARM                   06030000
         BCTR  R1,0                SUBTRACT ONE FOR EX ISN              06040000
         EX    R1,*+8              PACK ROUTCODE                        06050000
         B     *+10                BRANCH AROUND EX ISN                 06060000
         PACK  PACKWORK(8),0(0,R5) PACK ROUTCODE                        06070000
*                                                                       06080000
         CVB   R1,PACKWORK         CONVERT IT TO BINARY                 06090000
         BCTR  R1,0                SUBTRACT ONE FOR 1-16, NOT 0-15      06100000
         STC   R1,SHIFTISN+3       ALTER SHIFT ISN FOR CORRECT LENGTH   06110000
         L     R1,=X'00008000'     LOAD SEED                            06120000
SHIFTISN DS    0H                                                       06130000
         SRL   R1,0                SHIFT CORRECT AMOUNT                 06140000
         OR    R0,R1               ADD THIS ROUTCDE TO ACCUMULATOR      06150000
         STH   R0,ROUTCDE          STORE UPDATED ROUTCDE                06160000
         BR    R11                 RETURN TO CALLING ROUTINE            06170000
*                                                                       06180000
ROUTEND  DS    0H                                                       06190000
         MVC   WTOBUF+LMESSAGE(4),WTOCODES MOVE IN DESCRIPT & ROUTCDES  06200000
         LA    R0,LMESSAGE+4       GET WTO PARMLIST LENGTH              06210000
         STH   R0,WTO              STORE LENGTH IN PARMLIST             06220000
         OI    FLAGS,WTOIT         TURN ON FLAG TO ACTIVATE WTO RTN     06230000
         BR    R11                 RETURN TO CALLING ROUTINE            06240000
         EJECT                                                          06250000
*                                                                       06260000
*        LEVEL 3 ROUTINE (STEP PARM AND STEP END PROCESSING ROUTINES)   06270000
*                                                                       06280000
PARSSTEP DS    0H                                                       06290000
         L     R1,LISTPTR          LOAD CURRENT LIST POINTER            06300000
         L     R0,LISTNUM          LOAD CURRENT LIST ENTRY COUNTER      06310000
         BCT   R0,STPINIT1         DECREMENT COUNTER AND CONTINUE       06320000
*                                                                       06330000
         MVI   RETCODE+3,X'08'     SET NON-ZERO RETURN CODE             06340000
         LA    R1,PARMERR4         LOAD ADDRESS OF ERROR MESSAGE        06350000
         LA    R11,END             LOAD RETURN ADDRESS                  06360000
         B     ERRORRTN            GO TO ERROR ROUTINE                  06370000
*                                                                       06380000
STPINIT1 DS    0H                                                       06390000
         LR    R14,R5              COPY POINTER TO BEGINNING OF PARM    06400000
STPINIT2 DS    0H                                                       06410000
         LA    R15,1(,R14)         LOAD POINTER TO FIRST CHAR TO CHECK  06420000
STEPLOOP DS    0H                                                       06430000
         CR    R15,R6              IS THIS END OF PARM?                 06440000
         BNL   DELIMIT1            IS SO, PROCESS PARM                  06450000
*                                                                       06460000
         CLI   0(R15),C'.'         IS THIS DELIMITER FOR PRCSTPNM       06470000
         BE    DELIMIT2            IF SO, PROCESS IT                    06480000
*                                                                       06490000
         LA    R15,1(,R15)         ELSE, BUMP POINTER,                  06500000
         B     STEPLOOP            AND CONTINUE                         06510000
*                                                                       06520000
DELIMIT2 DS    0H                                                       06530000
         SR    R15,R14             CALCULATE LENGTH OF PARM             06540000
         BCTR  R15,0               SUBTRACT ONE FOR EX ISN              06550000
         EX    R15,*+8             MOVE STEPNAME INTO LIST              06560000
         B     *+10                BRANCH AROUND EX ISN                 06570000
         MVC   0(0,R1),0(R14)      EX ISN                               06580000
         LA    R14,2(R15,R14)      BUMP BASE TO PRCSTPNM                06590000
         B     STPINIT2            GO PROCESS PRCSTPNM                  06600000
*                                                                       06610000
DELIMIT1 DS    0H                                                       06620000
         SR    R15,R14             CALCULATE LENGTH OF PARM             06630000
         BCTR  R15,0               SUBTRACT ONE FOR EX ISN              06640000
         EX    R15,*+8             MOVE PRCSTPNM INTO LIST              06650000
         B     *+10                BRANCH AROUND EX ISN                 06660000
         MVC   8(0,R1),0(R14)      EX ISN                               06670000
         LA    R1,16(,R1)          BUMP POINTER TO NEXT SLOT IN LIST    06680000
*                                                                       06690000
         ST    R1,LISTPTR          STORE CURRENT LIST POINTER           06700000
         ST    R0,LISTNUM          STORE CURRENT LIST ENTRY COUNTER     06710000
         BR    R11                 RETURN TO CALLING ROUTINE            06720000
*                                                                       06730000
STEPEND  DS    0H                                                       06740000
         CLI   STEPLIST,C'*'       WAS "LIST ALL" FLAG NOT OVERWRITTEN? 06750000
         BNER  R11                 IF OVERWRITTEN, JUST RETURN          06760000
         MVI   STEPLIST,C' '       ELSE, BLANK FLAG OUT                 06770000
         BR    R11                 RETURN TO CALLING ROUTINE            06780000
*                                                                       06790000
LISTPTR  DC    A(STEPLIST)                                              06800000
LISTNUM  DC    A(NUMNAMES+1)                                            06810000
*                                                                       06820000
         TITLE 'ERROR MESSAGE ROUTINE'                                  06830000
*                                                                       06840000
ERRORRTN DS    0H                                                       06850000
         MVC   ERRORWTO+19(50),0(R1) MOVE ERROR MESSAGE INTO WTO        06860000
ERRORWTO WTO   'COMPCODE - 12345678901234567890123456789012345678901234X06870000
               567890',ROUTCDE=11                                       06880000
         BR    R11                 RETURN TO CALLING ROUTINE            06890000
*                                                                       06900000
PARMERR1 DC    CL50'PARMLIST DOES NOT END WITH A CLOSE PARENTHESIS'     06910000
*                                                                       06920000
PARMERR2 DC    CL50'PARMLIST CONTAINS UNRECOGINIZED KEYWORD'            06930000
*                                                                       06940000
PARMERR3 DC    CL50'OPEN PARENTHESIS NOT FOUND FOR KEYWORD'             06950000
*                                                                       06960000
PARMERR4 DC    CL50'MORE THAN 16 STEPNAMES SPECIFIED'                   06970000
*                                                                       06980000
PARMERR5 DC    CL50'UNABLE TO ISSUE SEND COMMANDS, NOT APF-AUTHORIZED'  06990000
*                                                                       07000000
         TITLE 'WTO, SEND, AND PRINT CONTROL BLOCK CONSTANTS'           07010000
*                                                                       07020000
WTOCODES DS    0H                                                       07030000
DSCPTCDE DC    B'0000000000000000' DESCRIPTOR CODES (NONE)              07040000
ROUTCDE  DC    B'0000000000000000' ROUTE CODE(S)                        07050000
*                                                                       07060000
*                                                                       07070000
WTO      DC    H'0'                TEXT LENGTH                          07080000
         DC    B'1000000000000000' MCS FLAGS                            07090000
WTOBUF   DC    CL80' '             MSG, DESCRIPTOR AND ROUTCDES         07100000
*                                                                       07110000
SEND     DC    H'0'                COMMAND LENGTH                       07120000
         DC    H'0'                CONSOLE ID                           07130000
         DC    C'SE ',X'7D'        MESSAGE PREFIX                       07140000
SENDBUF  DC    (LMESSAGE+22)C' '   ALLOW FOR MSG AND -                  07150000
*                                  ',USER=(XXXXXXX),LOGON   (22 CHARS)  07160000
*                                                                       07170000
PRINTBUF DC    CL133' '                                                 07180000
*                                                                       07190000
MESSAGE  DS    0H                                                       07200000
JOBNAME  DC    C'XXXXXXXX('                                             07210000
JESJOBID DC    C'XYYYY)- '                                              07220000
STEPNAME DC    C'XXXXXXXX'                                              07230000
PERIOD   DC    C'.'                                                     07240000
PRCSTPNM DC    C'XXXXXXXX '                                             07250000
RESULT   DC    C'         '                                             07260000
         DC    C'CODE '                                                 07270000
CONDCODE DC    C'XXXX   '                                               07280000
DATE     DC    C'XX.XXX '                                               07290000
TIME     DC    C'XX:XX:XX'                                              07300000
*LMESSAGE EQU   *-MESSAGE                                         *JLM* 07310000
*                                                                       07320000
         TITLE 'SNAPDUMP CONSTANTS'                                     07330000
*                                                                       07340000
SNAPLIST DS    F                                                        07350000
SNAPEND  DS    F                                                        07360000
HDRLIST  DS    F                                                        07370000
*                                                                       07380000
JCTHDR   DC    AL1(LJCTHDR-1)                                           07390000
         DC    C'SNAP DUMP OF JOB CONTROL TABLE (JCT)'                  07400000
LJCTHDR  EQU   *-JCTHDR                                                 07410000
*                                                                       07420000
SSIBHDR  DC    AL1(LSSIBHDR-1)                                          07430000
         DC    C'SUBSYSTEM IDENTIFICATION BLOCK (SSIB)'                 07440000
LSSIBHDR EQU   *-SSIBHDR                                                07450000
*                                                                       07460000
SCTHDR   DC    AL1(LSCTHDR-1)                                           07470000
         DC    C'STEP CONTROL TABLE (SCT) (ONE PER STEP)'               07480000
LSCTHDR  EQU   *-SCTHDR                                                 07490000
*                                                                       07500000
         TITLE 'OTHER MISCELANEOUS CONSTANTS'                           07510000
*                                                                       07520000
PACKWORK DS    D                                                        07530000
RETCODE  DC    F'0'                                                     07540000
ABEND    DS    F,X                                                      07550000
DATEWORK DS    CL5                                                      07560000
TIMEWORK DS    CL7                                                      07570000
FLAGS    DC    X'00'                                                    07580000
*                                                                       07590000
SENDIT   EQU   X'80'                                                    07600000
WTOIT    EQU   X'40'                                                    07610000
PRINTIT  EQU   X'20'                                                    07620000
SNAPIT   EQU   X'10'                                                    07630000
*                                                                       07640000
ABENDED  DC    CL9'ABENDED,'                                            07650000
FLUSHED  DC    CL9'FLUSHED,'                                            07660000
ENDED    DC    CL9'ENDED,'                                              07670000
*                                                                       07680000
STEPLIST DC    CL16'*'                                                  07690000
         DC    15CL16' '                                                07700000
NUMNAMES EQU   (*-STEPLIST)/16                                          07710000
*                                                                       07720000
         PRINT NOGEN                                                    07730000
SYSPRINT DCB   DDNAME=SYSPRINT,                                        X07740000
               DSORG=PS,                                               X07750000
               MACRF=PM,                                               X07760000
               RECFM=FB,                                               X07770000
               LRECL=133,                                              X07780000
               EXLST=DCBEXIT                                            07790000
*                                                                       07800000
DCBEXIT  DCBEXIT BLKSIZE=6118      SEE MACRO EXPANSION                  07810000
*                                                                       07820000
SNAPDUMP DCB   DDNAME=SNAPDUMP,                                        X07830000
               DSORG=PS,                                               X07840000
               MACRF=W,                                                X07850000
               RECFM=VBA,                                              X07860000
               LRECL=125,                                              X07870000
               BLKSIZE=1632                                             07880000
*                                                                       07890000
         IHAPSA                    PSA DSECT                            07900000
         IKJTCB                    TCB DSECT                            07910000
         IEZJSCB                   JSCB DSECT                           07920000
         IEFJSSIB                  SSIB DSECT                           07930000
         IEFAJCTB                  JCT DSECT                            07940000
         IEFASCTB                  SCT DSECT                            07950000
         IEFTIOT1                  TIOT DSECT                           07960000
         IHADCB DSORG=PS           DCB DSECT                            07970000
         END                                                            07980000
//LKED.SYSLMOD DD DSN=SYS2.LINKLIB,DISP=MOD    <- TARGET LINK LIBRARY   07990000
//LKED.SYSIN DD *                                                       08000000
  SETCODE AC(1)                                                         08010000
  NAME COMPCODE(R)                                                      08020000
//                                                                      08030000
